/*
Questa versione del programma non usa l'allocazione
dinamica per il vettore dei numeri.
Peranto e' in grado di gestire un numero di
valori pari a 10 come indicato nella dichiarazione
del vettore "value".
Vedere il file leggi_file_malloc.c per la versione
del programma che usa la memoria dinamica e confrontare
le 2 alternative.
*/

#include <stdio.h>

int main(int arg, char *args[]) {

	FILE *source;
	FILE *dest;
	int i;

	/*
	Il vettore ha dimensione fissa e pu contenere solo 10 interi!!
	Ricordare che il nome del vettore  un puntatore
	*/
	int value[10];		
	
	float med = 0;
	
	if(arg != 3)
		printf("\nUsage: leggi_file.x <source file> <dest file>\n\n");
	else {
		
		source = fopen(args[1], "r");
		
		if(source == NULL)
			printf("Errore nell'apertura. File non trovato.\n");

		else {
						
			for(i=0; i<10; i++) {
				fscanf(source, "%d", &value[i]);
				/*
				Avrei potuto scrivere anche
				fscanf(source, "%d", value+i); ????
				*/
			}		
					
			fclose(source);
			
			for(i=0; i<10; i++)
				med += value[i];
				/*
				Avrei potuto scrivere anche
				med += *(value+i); ????
				oppure 
				med += *value[&i]; ????
				*/			
				
			med /= 10;			
			
			dest = fopen(args[2], "w");
			
			for(i=0; i<10; i++)
				fprintf(dest, "%d\n", value[i]);				
			
			fprintf(dest, "Media = %f\n", med);							
			
			fclose(dest);
	
			printf("Operazione effettuata. I valori sono stati salvati sul file %s\n\n",args[2]);
		}
	}		
}
