/* ERRORE SINTATTICO 1 -- eliminato include */
#include <stdio.h>
#include <string.h>

char * string_process(FILE *source);

/* ERRORE SINTATTICO 2 -- eliminate le parentesi quadrate su args*/
int main(int arg, char *args[]) {

	FILE *source;
	char *s;		//stringa che contiene la concatenazione	
		
	if(arg != 2)
		printf("\nUsage: stringa.x <source file>\n\n");
	else {
	
		 /* ERRORE SEMANTICO 1 -- "a" al posto di "r" */
		source = fopen(args[1], "r");
		
		/* ERRORE SEMANTICO 2 -- != al posto di == */
		if(source == NULL)
		
			printf("Errore nell'apertura. File non trovato.\n");

		else {
			
			/* ERRORE SINTATTICO 3 -- stringprocess al posto di string_process */
			s = string_process(source);
			
			/* ERRORE SEMANTICO 3 -- %d al posto di %s*/
			printf("Stringa concatenata ed invertita = %s\n", s);										

			fclose(source);
		}
	}		
}

/* ERRORE SINTATTICO 4 -- tolto l'asterisco */
char * string_process(FILE *source) {
	char s1[51];		//stringa 1
	char s2[51];		//stringa 2
	char temp1[50];	//stringa temporanea per l'inversione di s1
	char temp2[50];	//stringa temporanea per l'inversione di s2
	
	/* ERRORE SEMANTICO 5 -- s non pu essere definita semplicemente
	come char s[101] perch essendo una variabile locale il suo spazio viene 
	liberato appena si esce dalla funzione.
	Le soluzioni a questo problema sono molteplici.
	1) dichiarare s come static
	2) allocare lo spazio nel main e passarlo alla funzione string_process
		 come parametro
	3) nel main effettuare una copia del valore ritornato dalla chiamata alla
   	 string_process usando la strcpy.
	4) usare la malloc per allocare spazio per s dentro alla string_process. 
		 Questa  la peggiore tra le soluzioni perch dopo aver terminato di 
		 usare s bisognerebbe liberare la memoria alloccata con una chimata 
		 alla funzione free.
		 Ovviamente per la funzione free non pu essere chiamata dentro alla
		 string_process altrimenti si torna al problema iniziale. Quindi la memoria
		 viene sprecata e rimane alloccata anche quando non sarebbe necessario.
	 */
	static char s[101];		//stringa che contiene la concatenazione	

	char c;
	/* ERRORE SINTATTICO 5 -- tolta la dichiarazione di i */
	int i = 0;
	int l = 0;			//lunghezza della stringa
	
	char *ret;
	
	c = getc(source);											
	while(c != ';') {
		s1[i] = c;
		
		/* ERRORE SINTATTICO 6 -- get al posto di getc */
		c = getc(source);			
		i++;															
	}				
	s1[i] = '\0';
	
	i = 0;
	c = getc(source);											
	while(c != '\n') {
		s2[i] = c;
		c = getc(source);			
	i++;															
	}	
	/* ERRORE SEMANTICO 4 -- dimenticato il tappo */			
	s2[i] = '\0';
	
	l = strlen(s1);
	for (i=0; i<l; i++)
		temp1[i] = s1[l-1-i];
	temp1[i] = '\0';	
					
	l = strlen(s2);
	for (i=0; i<l; i++)
		temp2[i] = s2[l-1-i];							
	temp2[i] = '\0';					
	
	printf("s1 = %s\n", s1);
	printf("s2 = %s\n", s2);			
	printf("temp1 = %s\n", temp1);
	printf("temp2 = %s\n", temp2);	
	
	s[0] = '\0';
	strcat(s, temp1);
	
	/* ERRORE SINTATTICO 7 -- Tolte " */
	printf("s = %s\n", s);	
	
	strcat(s, temp2);
	
	printf("s = %s\n", s);	
	
	ret = s;	
	return ret;
}
